/*CMZ :          28/10/98  14.47.32  by  Masaharu Goto*/
/*-- Author :    Masaharu Goto   28/10/98*/
/* /% C %/ */
/***********************************************************************
 * cint (C/C++ interpreter)
 ************************************************************************
 * Source file macro.c
 ************************************************************************
 * Description:
 *  Define macro
 ************************************************************************
 * Copyright(c) 1991~1996  [hp] Hewlett Packard Japan, All rights reserved
 * Author                  Masaharu Goto (gotom@jpn.hp.com)
 * Copyright(c) 1995~1998  Masaharu Goto (MXJ02154@niftyserve.or.jp)
 *
 * Permission to use, copy, modify and distribute this software and its
 * documentation for any purpose is hereby granted without fee,
 * provided that the above copyright notice appear in all copies and
 * that both that copyright notice and this permission notice appear
 * in supporting documentation.  Hewlett-Packard Japan Company makes no
 * representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied warranty.
 ************************************************************************/

/*KEEP,common.*/
#include "common.h"
/*KEND.*/



/******************************************************************
* void G__define()
*
* Called by
*   G__exec_statement()
*
******************************************************************/
void G__define()
/* struct G__input_file *fin; */
{
  /*  #define [NAME] [VALUE] \n => G__letvariable("NAME","VALUE") */

  char new_name[G__ONELINE],initvalue[G__ONELINE];
  G__value evalval;
  int c;
  /* int flag; */
  fpos_t pos;
  /* int inew=0; */

  /*
   *  #define   macro   value
   *          ^
   * read macro name
   */

  c=G__fgetname(new_name,"(\n\r");

  /*
   *  #define   macro   value
   *                  ^
   */

  /*
   * function macro not supported
   */
  if(c=='(') {
    G__createfuncmacro(new_name);
    G__fignoreline();
    return;
  }

  /* if
   *  #define   macro\n
   *                   ^
   *  #define   macro    value  \n
   *                  ^
   * no value , don't read
   */
  if(c!='\n' && c!='\r') {
    fgetpos(G__ifile.fp,&pos);
#ifndef G__OLDIMPLEMENtATION433
    c=G__fgetstream(initvalue,"\n\r\\/");
    if('/'==c) {
      c=G__fgetc();
      switch(c) {
      case '/':
	G__fignoreline();
	c='\n';
	break;
      case '*':
	G__skip_comment();
	c=G__fgetstream(initvalue+strlen(initvalue),"\n\r\\/");
	break;
      default:
	sprintf(initvalue+strlen(initvalue),"/%c",c);
	c=G__fgetstream(initvalue+strlen(initvalue),"\n\r\\/");
	break;
      }
    }
#else
    c=G__fgetstream(initvalue,"\n\r\\");
#endif
    if(c=='\\') {
      fsetpos(G__ifile.fp,&pos);
      G__createmacro(new_name,initvalue);
      return;
    }
  }
  else {
    initvalue[0]='\0';
  }


  /*
   *  #define   macro   value \n
   *                            ^
   *  macro over
   */

  if(initvalue[0] &&
     ('*'==initvalue[strlen(initvalue)-1] ||
      strcmp(initvalue,"int")==0 ||
      strcmp(initvalue,"short")==0 ||
      strcmp(initvalue,"char")==0 ||
      strcmp(initvalue,"long")==0 ||
      strcmp(initvalue,"unsignedint")==0 ||
      strcmp(initvalue,"unsignedshort")==0 ||
      strcmp(initvalue,"unsignedchar")==0 ||
      strcmp(initvalue,"unsignedlong")==0 ||
#ifndef G__OLDIMPLEMENTATION866
      strcmp(initvalue,"signedint")==0 ||
      strcmp(initvalue,"signedshort")==0 ||
      strcmp(initvalue,"signedchar")==0 ||
      strcmp(initvalue,"signedlong")==0 ||
#endif
      strcmp(initvalue,"double")==0 ||
      strcmp(initvalue,"float")==0 ||
      -1!=G__defined_typename(initvalue)||
      -1!=G__defined_tagname(initvalue,2)||
      G__defined_templateclass(initvalue))) {
    /* '#define newtype type *'
     * handle as 'typedef type* newtype;'
     */
    evalval=G__null;
  }
  else {
    evalval=G__calc(initvalue);
  }

  if(G__null.type==evalval.type && initvalue[0]) {
    /* #define newtype oldtype
     * handled as typedef oldtype newtype;
     */
    G__handle_as_typedef(initvalue,new_name);
  }
  else {
    /* define as an automatic variable */
    G__var_type = 'p';
    G__typenum = -1;
    G__tagnum = -1;
    G__macro_defining=1;
    G__letvariable(new_name,evalval,&G__global,G__p_local);
    G__macro_defining=0;
  }
}

/***********************************************************************
* int G__handle_as_typedef(oldtype,newtype)
***********************************************************************/
int G__handle_as_typedef(oldtype,newtype)
char *oldtype,*newtype;
{
  int type='\0' , tagnum = -1 ,ispointer=0 , isunsigned;
  int typenum;
  char *p, *ptype;

  p = strchr(oldtype,'*');
  if(p) {
    ispointer = 'A'-'a';
    *p='\0';
  }
  else {
    ispointer=0;
  }

  if(strncmp(oldtype,"unsigned",8)==0) {
    ptype=oldtype+8;
    isunsigned = -1; /* 0 */
  }
#ifndef G__OLDIMPLEMENTATION866
  else if(strncmp(oldtype,"signed",6)==0) {
    ptype=oldtype+6;
    isunsigned = 0;
  }
#endif
  else {
    ptype=oldtype;
    isunsigned = 0; /* -1 */
  }

  if(strcmp(ptype,"int")==0) {
    type='i'+ispointer+isunsigned;
  }
  else if(strcmp(ptype,"char")==0) {
    type='c'+ispointer+isunsigned;
  }
  else if(strcmp(oldtype,"double")==0) {
    type='d'+ispointer; /* bug fix */
  }
  else if(strcmp(ptype,"short")==0) {
    type='s'+ispointer+isunsigned;
  }
  else if(strcmp(ptype,"long")==0) {
    type='l'+ispointer+isunsigned;
  }
  else if(strcmp(oldtype,"float")==0) {
    type='f'+ispointer;
  }
  else if(strncmp(oldtype,"struct",6)==0) {
    ptype=oldtype+6;
    type='u'+ispointer;
    tagnum=G__defined_tagname(ptype,0);
  }
  else if(strncmp(oldtype,"class",5)==0) {
    ptype=oldtype+5;
    type='u'+ispointer;
    tagnum=G__defined_tagname(ptype,0);
  }
  else if(strncmp(oldtype,"enum",4)==0) {
    ptype=oldtype+4;
    type='i'+ispointer;
    tagnum=G__defined_tagname(ptype,0);
  }
  else {
#ifndef G__OLDIMPLEMENTATION867
    tagnum=G__defined_tagname(oldtype,1);
    if(tagnum>=0) {
      type = 'u'+ispointer;
    }
    else {
      typenum=G__defined_typename(oldtype);
      if(typenum>=0) {
	type = G__newtype.type[typenum];
	tagnum=G__newtype.tagnum[typenum];
      }
    }
#else
    typenum=G__defined_typename(ptype);
    type = G__newtype.type[typenum];
    tagnum=G__newtype.tagnum[typenum];
#endif
  }

  if(type) {
#ifndef G__OLDIMPLEMENTATION734
    if(strcmp(newtype,"bool")!=0) {
      fprintf(G__serr,"Limitation: macro handled as typedef %s %s;"
	      ,oldtype,newtype);
      G__printlinenum();
    }
    G__search_typename(newtype,type,tagnum,0);
#else
    fprintf(G__serr,"Limitation: macro handled as typedef %s %s;"
	    ,oldtype,newtype);
    G__search_typename(newtype,type,tagnum,0);
    G__printlinenum();
#endif
  }
#ifndef G__OLDIMPLEMENTATION734
  /* this is only workaround for STL Allocator */
  else if(strcmp(newtype,"Allocator")==0) {
    strcpy(G__Allocator,oldtype);
  }
  else if(strcmp(newtype,"vector")==0) {
  }
  else if(strcmp(newtype,"list")==0) {
  }
  else if(strcmp(newtype,"deque")==0) {
  }
  else if(strcmp(newtype,"rb_tree")==0) {
  }
#endif
  else {
    fprintf(G__serr,"Limitation: can not handle macro %s %s" ,newtype,oldtype);
    if(0==G__cpp) fprintf(G__serr," Use +P or -p option\n");
    G__genericerror((char*)NULL);
  }

  return(0);
}


/**************************************************************************
* G__createmacro()
**************************************************************************/
void G__createmacro(new_name,initvalue)
char *new_name;
char *initvalue;
{
  char line[G__ONELINE];
  int c;
  char *p,*null_fgets;
  fpos_t pos;
  G__value evalval;

  /* Set flag that there is a macro or template in the source file,
   * so that this file won't be closed even with -cN option */
  ++G__macroORtemplateINfile;

  if(G__mfp==NULL) {
#ifdef G__DEBUG
    fprintf(G__serr,"Limitation: This form of macro may not be expanded. Use +P or -p option");
    G__printlinenum();
#endif
    G__openmfp();
    fgetpos(G__mfp,&G__nextmacro);
    G__mline=1;
  }
  else {
    fsetpos(G__mfp,&G__nextmacro);
  }


  /* print out header */
  ++G__mline;
  fprintf(G__mfp,"// #define %s  FILE:%s LIEN:%d\n"
	  ,new_name
	  ,G__ifile.name,G__ifile.line_number);

  fgetpos(G__mfp,&pos);

  fprintf(G__mfp,"# %d\n",++G__mline);
  ++G__mline;
  fprintf(G__mfp,"{\n");

#ifndef G__OLDIMPLEMENTATION431
  fprintf(G__mfp,"%s\n",initvalue);
#endif

  /* translate macro */
  do {
    null_fgets=fgets(line,G__ONELINE,G__ifile.fp);
    if(null_fgets==NULL) {
      G__unexpectedEOF("G__createmacro()");
    }
    ++G__ifile.line_number;
    p=strchr(line,'\n');
    if(p) {
      *p = '\0';
    }
    else {
      p=strchr(line,'\r');
      if(p) *p = '\0';
    }
    c='\n';
    if(*(p-1)=='\\') {
      *(p-1) = '\0';
      c='\\';
    }
    if(G__dispsource) {
      fprintf(G__serr,"\\\n%-5d",G__ifile.line_number);
      fprintf(G__serr,"%s",line);
    }
    ++G__mline;
    fprintf(G__mfp,"%s\n",line);
#ifndef G__OLDIMPLEMENTATION454
#endif
  } while(c!='\n' && c!='\r' );

  p = strrchr(line,';');
  ++G__mline;
  if(p==NULL) {
    fprintf(G__mfp,";}\n");
  }
  else {
    fprintf(G__mfp,"}\n");
  }
  fgetpos(G__mfp,&G__nextmacro);

  G__var_type = 'm';
  G__typenum = -1;
  G__tagnum = -1;
#ifndef G__FONS30
  evalval.obj.i = (long)(&pos);
#else
  evalval.obj.i = (int)(&pos);
#endif
  G__letvariable(new_name,evalval,&G__global,G__p_local);
  G__var_type = 'p';
}

/**************************************************************************
* G__execfuncmacro()
*
* Execute function macro
*
*  input  char *item :  macro(para,para)
*  output int *done  :  1 if macro function called, 0 if no macro found
*
**************************************************************************/
G__value G__execfuncmacro(item,done)
char *item;
int *done;
{
  G__value result;
  struct G__Deffuncmacro *deffuncmacro;
  struct G__Callfuncmacro *callfuncmacro;
  char *p;
  char funcmacro[G__ONELINE];
  int hash,i;
  int found;

  fpos_t call_pos;
  struct G__input_file store_ifile;


  /* separate macro func name */
  G__ASSERT(strlen(item)<G__ONELINE);
  strcpy(funcmacro,item);
  p = strchr(funcmacro,'(');
  *p='\0';
  /* get hash */
  G__hash(funcmacro,hash,i)

  /* search for macro func name */
  found=0;
  deffuncmacro = &G__deffuncmacro;
  while(deffuncmacro->next) {
    if(hash==deffuncmacro->hash && strcmp(funcmacro,deffuncmacro->name)==0) {
      found=1;
      break;
    }
    deffuncmacro=deffuncmacro->next;
  }

  if(0==found) {
    *done = 0;
    return (G__null);
  }


  /* store calling file pointer and position */
  fgetpos(G__ifile.fp,&call_pos);
  store_ifile = G__ifile;


  /* search for translated macro function */
  found=0;
  callfuncmacro = &deffuncmacro->callfuncmacro;
  while(callfuncmacro->next) {
#ifdef G__NONSCALARFPOS
    if(G__ifile.line_number == callfuncmacro->line &&
       G__ifile.fp == callfuncmacro->call_fp) {
#else
    if(call_pos == callfuncmacro->call_pos &&
       G__ifile.fp == callfuncmacro->call_fp) {
#endif
      found=1;
      break;
    }
    callfuncmacro = callfuncmacro->next;
  }

  /* substitute macro if not already being done so */
  if(0==found) {
    G__transfuncmacro(item,deffuncmacro,callfuncmacro,call_pos,p);
  }

  /* set macro file */
  G__ifile.fp = G__mfp;
  fsetpos(G__ifile.fp,&callfuncmacro->mfp_pos);
  strcpy(G__ifile.name,G__macro);

  /* execute macro function */
  G__nobreak=1;
  result=G__exec_statement();
  G__nobreak=0;

  /* re-store source file information */
  G__ifile = store_ifile;
#ifndef G__OLDIMPLEMENTATION901
  if(G__ifile.filenum>=0)
    G__security = G__srcfile[G__ifile.filenum].security;
  else
    G__security = G__SECURE_LEVEL0;
#else
  G__security = G__srcfile[G__ifile.filenum].security;
#endif
  fsetpos(G__ifile.fp,&call_pos);

  *done = 1;
  return(result);
}
/**************************************************************************
* G__transfuncmacro()
*
* translate function macro parameter at the first execution of func macro
*
**************************************************************************/
int G__transfuncmacro(item,deffuncmacro,callfuncmacro,call_pos,p)
char *item;
struct G__Deffuncmacro *deffuncmacro;
struct G__Callfuncmacro *callfuncmacro;
fpos_t call_pos;
char *p;
{
  struct G__Charlist call_para;

  /* set file pointer and position */
  callfuncmacro->call_fp = G__ifile.fp;
  callfuncmacro->call_pos = call_pos;
#ifndef G__OLDIMPLEMENTATION469
  callfuncmacro->line = G__ifile.line_number;
#endif

  /* allocate and initialize next list */
  callfuncmacro->next = (struct G__Callfuncmacro*)malloc(sizeof(struct G__Callfuncmacro));
  callfuncmacro->next->next = (struct G__Callfuncmacro*)NULL;
  callfuncmacro->next->call_fp = (FILE*)NULL;

  /* get parameter list */
  G__getparameterlist(p+1,&call_para);

  /* translate macro function */
  G__replacefuncmacro(item
		      ,callfuncmacro
		      ,&call_para
		      ,&deffuncmacro->def_para
		      ,deffuncmacro->def_fp
		      ,deffuncmacro->def_pos
		      );

  G__freecharlist(&call_para);

  return(1);
}

/**************************************************************************
* G__replacefuncmacro()
*
* Replace function macro parameter at the first execution of func macro
*
**************************************************************************/
int G__replacefuncmacro(item,callfuncmacro,callpara,defpara,def_fp,def_pos)
char *item;
struct G__Callfuncmacro *callfuncmacro;
struct G__Charlist *callpara,*defpara;
FILE *def_fp;
fpos_t def_pos;
{
  fpos_t pos;
  int c;
  int semicolumn;
  char symbol[G__ONELINE];
  char *punctuation=" \t\n;:=+-)(*&^%$#@!~'\"\\|][}{/?.>,<";
  int double_quote=0,single_quote=0;

  if(G__mfp==NULL) {
#ifdef G__DEBUG
    fprintf(G__serr,"Limitation: This form of macro may not be expanded. Use +P or -p option");
    G__printlinenum();
#endif
    G__openmfp();
    fgetpos(G__mfp,&G__nextmacro);
    G__mline=1;
  }
  else {
    fsetpos(G__mfp,&G__nextmacro);
  }

  /* print out header */
  ++G__mline;
  fprintf(G__mfp,"// #define %s  FILE:%s LIEN:%d\n"
	  ,item
	  ,G__ifile.name,G__ifile.line_number);

  fgetpos(G__mfp,&pos);
  callfuncmacro->mfp_pos = pos;

  fprintf(G__mfp,"# %d\n",++G__mline);
  ++G__mline;
  fprintf(G__mfp,"{\n");

  /*******************************************************************
   * read macro definition and substitute symbol
   *******************************************************************/
  /* set file pointer and position */
  G__ifile.fp = def_fp;
  fsetpos(def_fp,&def_pos);

  /* read definition and substitute */
  semicolumn = 0;
  while(1) {
    G__disp_mask = 10000;
    c = G__fgetstream(symbol,punctuation);
    if('\0' != symbol[0]) {
      if(0==double_quote && 0==single_quote)
	G__argsubstitute(symbol,callpara,defpara);
      fprintf(G__mfp,"%s",symbol);
      semicolumn = 0;
    }

    if(0==single_quote && 0==double_quote) {
      if('\n'==c || '\r'==c) break;
      if('\\'==c) {
	c=G__fgetc();
#ifndef G__OLDIMPLEMENTATION454
	if('\r'==c||'\n'==c) c=G__fgetc();
#endif
      }

      if(';'==c) {
	semicolumn = 1;
      }
      else if(!isspace(c)) {
	semicolumn = 0;
      }
    }

    if('\''==c && 0==double_quote)
      single_quote = single_quote ^ 1 ;

    else if('"'==c && 0==single_quote)
      double_quote = double_quote ^ 1 ;

    fputc(c,G__mfp);
#ifndef G__OLDIMPLEMENTATION454
    if('\n'==c) ++G__mline;
#else
    if('\n'==c || '\r'==c) ++G__mline;
#endif
  }

  /* finishing up */
  G__disp_mask=0;
  if(0==semicolumn) fprintf(G__mfp," ;");
  G__mline+=2;
  fprintf(G__mfp,"\n}\n");
  fgetpos(G__mfp,&G__nextmacro);

  fflush(G__mfp);

  return(0);
}

/**************************************************************************
* G__argsubstitute()
*
* Substitute macro argument
*
**************************************************************************/
int G__argsubstitute(symbol,callpara,defpara)
char *symbol;
struct G__Charlist *callpara,*defpara;
{
  while(defpara->next) {
    if(strcmp(defpara->string,symbol)==0) {
      strcpy(symbol,callpara->string);
      break;
    }
    defpara = defpara->next;
    callpara=callpara->next;
  }
  return(0);
}

/**************************************************************************
* G__createfuncmacro()
*
* Create deffuncmacro list when prerun
*
**************************************************************************/
int G__createfuncmacro(new_name)
char *new_name;
{
  struct G__Deffuncmacro *deffuncmacro;
  int hash,i;
  char paralist[G__ONELINE];
  int c;

  /* Set flag that there is a macro or template in the source file,
   * so that this file won't be closed even with -cN option */
  ++G__macroORtemplateINfile;

  /* Search for the end of list */
  deffuncmacro = &G__deffuncmacro;
  /*
    fprintf(G__serr ,"Limitation: Macro %s() may not work well" ,new_name);
    G__printlinenum();
  */
  while(deffuncmacro->next) deffuncmacro=deffuncmacro->next;

  /* store name */
  deffuncmacro->name = malloc(strlen(new_name)+1);
  strcpy(deffuncmacro->name,new_name);

  /* store hash */
  G__hash(new_name,hash,i)
    deffuncmacro->hash=hash;

  /* read parameter list */
  c = G__fgetstream(paralist,")");
  G__ASSERT(')'==c);
  G__getparameterlist(paralist,&deffuncmacro->def_para);

  /* store file pointer, line number and position */
  deffuncmacro->def_fp = G__ifile.fp;
  fgetpos(G__ifile.fp,&deffuncmacro->def_pos);
  deffuncmacro->line = G__ifile.line_number;


  /* allocate and initialize next list */
  deffuncmacro->next = (struct G__Deffuncmacro*)malloc(sizeof(struct G__Deffuncmacro));
  deffuncmacro->next->callfuncmacro.next = (struct G__Callfuncmacro*)NULL;
  deffuncmacro->next->callfuncmacro.call_fp = (FILE *)NULL;
  deffuncmacro->next->def_para.string = (char*)NULL;
  deffuncmacro->next->def_para.next = (struct G__Charlist*)NULL;
  deffuncmacro->next->next = (struct G__Deffuncmacro*)NULL;
  deffuncmacro->next->name = (char*)NULL;
  deffuncmacro->next->hash = 0;

  /* after this, source file is read to end of line */

  return(0);
}

/**************************************************************************
* G__getparameterlist()
**************************************************************************/
int G__getparameterlist(paralist,charlist)
char *paralist;
struct G__Charlist *charlist;
{
  int isrc;
  char string[G__ONELINE];
  int c;

  c=',';
  isrc=0;
  while(','==c) {
#ifdef G__TEMPLATECLASS
    c = G__getstream_template(paralist,&isrc,string,",)\0");
#else
    c = G__getstream(paralist,&isrc,string,",)\0");
#endif

    charlist->string = malloc(strlen(string)+1);
    strcpy(charlist->string,string);
    charlist->next = (struct G__Charlist*)malloc(sizeof(struct G__Charlist));
    charlist->next->next = (struct G__Charlist *)NULL;
    charlist->next->string = (char *)NULL;
    charlist = charlist->next;
  }

  return(0);
}
/**************************************************************************
* G__freedeffuncmacro()
**************************************************************************/
int G__freedeffuncmacro(deffuncmacro)
struct G__Deffuncmacro *deffuncmacro;
{
  if(deffuncmacro->next) {
    G__freedeffuncmacro(deffuncmacro->next);
    free((void*)deffuncmacro->next);
    deffuncmacro->next=(struct G__Deffuncmacro *)NULL;
  }
  G__freecallfuncmacro(&deffuncmacro->callfuncmacro);
  G__freecharlist(&deffuncmacro->def_para);
  if(deffuncmacro->name) {
    free((void*)deffuncmacro->name);
    deffuncmacro->name=(char*)NULL;
  }
  return(0);
}

/**************************************************************************
* G__freecallfuncmacro()
**************************************************************************/
int G__freecallfuncmacro(callfuncmacro)
struct G__Callfuncmacro *callfuncmacro;
{
  if(callfuncmacro->next) {
    G__freecallfuncmacro(callfuncmacro->next);
    free((void*)callfuncmacro->next);
    callfuncmacro->next=(struct G__Callfuncmacro *)NULL;
  }
  return(0);
}

/**************************************************************************
* G__freecharlist()
**************************************************************************/
int G__freecharlist(charlist)
struct G__Charlist *charlist;
{
  if(charlist->next) {
    G__freecharlist(charlist->next);
    free((void*)charlist->next);
    charlist->next=(struct G__Charlist *)NULL;
  }
  if(charlist->string) {
    free((void*)charlist->string);
    charlist->string=(char*)NULL;
  }
  return(0);
}


/*
 * Local Variables:
 * c-tab-always-indent:nil
 * c-indent-level:2
 * c-continued-statement-offset:2
 * c-brace-offset:-2
 * c-brace-imaginary-offset:0
 * c-argdecl-indent:0
 * c-label-offset:-2
 * compile-command:"make -k"
 * End:
 */
